{% extends "template/app.twig" %}

{% block meta %}
    {% set meta = {'keywords': 'Empresas'} %}
    {{ parent() }}
{% endblock %}

{% block link %}
    {{ parent() }}
    <style>#calendar .fc-toolbar .fc-center{margin-top:38px !important;}</style>
{% endblock %}

{% block header %}
    {{ parent() }}
{% endblock %}

{% block aside %}
    {{ parent() }}
{% endblock %}

{% block content %}
    {{ parent() }}
    {% include "template/partial/section/calendar.twig" %}
{% endblock %}

{% block footer %}
    {{ parent() }}
{% endblock %}

{% block script %}
    {{ parent() }}

    <style>.disabled{background: #eee}</style>
    <script type="text/javascript">
        jQuery(function($){            
            $(document).ready(function () {
                var date = new Date();
                var h = date.getHours();

                var cId = $('#calendar'); //Change the name if you want. I'm also using thsi add button for more actions

                //Generate the Calendar
                cId.fullCalendar({
                    header: {
                        right: '',
                        center: 'prev, title, next',
                        left: ''
                    },
                    theme: true, //Do not remove this as it ruin the design
                    selectable: true,
                    selectHelper: true,
                    editable: true,
                    //Add Events
                    events: [{{calendar|raw}}],
                    /*        
                    [
                        {
                            title: 'Job Interview',
                            start: new Date(y, m, 30, 15, 0, 0),
                            end: new Date(y, m, 30, 18, 0, 0),
                            allDay: false,
                            className: 'palette-Green bg'
                        }
                    ],*/
                    //On Day Select
                    select: function (start, end, allDay) {                        
                        var minDate = moment();

                        if (start._d.getDay() == 6 || start._d.getDay() == 5){
                            notify("La fecha no puede ser sobre el fin de semana", 'warning');
                        }else if (minDate > start && minDate > end) {
                            notify("La fecha no puede ser menor al día de hoy", 'warning');
                        } else {
                            $('#addNew-event :input').val('');
                            
                            $(".modal-title").text('Adicionar actividad/reunión (Calendario Genérico)');
                            $('#milestone_date').val(getDateView(end));
                            $('#milestone_start_time').val(h+":00");
                            $('#milestone_end_time').val(h+":30");
                            $('button.view-edit').text('Crear evento').attr('data-action', 'POST');
                            //$("#new-calendar :input").attr("disabled", false);
                            $('#addNew-event').modal('show');

                            $('#getStart').val(start);
                            $('#getEnd').val(end);
                            
                            $("#client_id").selectpicker('refresh');

                        }
                    },
                    dayRender: function(d, cell) {
                        console.log('dayRender');
                        console.log(cell);
                        
                        var da = moment().add(-1, 'day');
                        if (da > d) {
                            $(cell).addClass('disabled');
                        }
                        
                        if (d._d.getDay() == 5 || d._d.getDay() == 6){
                            $(cell).addClass('disabled');
                        }
                    },
                    eventClick: function(calEvent, jsEvent, view) {
                        // change the border color just for fun
                        //$(this).css('border-color', 'red');
                        console.log(calEvent);
                        $('#addNew-event :input').val('');
                        
                        $(".modal-title").text('Actividad');

                        $('#client_id').selectpicker('val', calEvent.client_id);
                        
                        $('#milestone_id').val( calEvent._id );
                        $("#milestone_title").val(calEvent.title);
                        $("#milestone_detail").val(calEvent.description);
                        $('#milestone_date').val( getDateView(calEvent.start) );
                        $('#milestone_start_time').val( calEvent.time_start );
                        $('#milestone_end_time').val( calEvent.time_end );
                        
                        $('button.view-edit').text('Editar evento').attr('data-action', 'PUT');
                        //$("#new-calendar :input").attr("disabled", true);
                        
                        $('#addNew-event').modal('show');
                        
                        getUserParentMilestone(calEvent._id);
                        getContactMilestone(calEvent._id);
                    }
                    /*
                    viewRender: function(currentView){
                        var minDate = moment(),
                        maxDate = moment().add(2,'weeks');
                        // Past
                        if (minDate >= currentView.start && minDate <= currentView.end) {
                                $(".fc-prev-button").prop('disabled', true); 
                                $(".fc-prev-button").addClass('fc-state-disabled'); 
                        }
                        else {
                                $(".fc-prev-button").removeClass('fc-state-disabled'); 
                                $(".fc-prev-button").prop('disabled', false); 
                        }
                        // Future
                        if (maxDate >= currentView.start && maxDate <= currentView.end) {
                                $(".fc-next-button").prop('disabled', true); 
                                $(".fc-next-button").addClass('fc-state-disabled'); 
                        } else {
                                $(".fc-next-button").removeClass('fc-state-disabled'); 
                                $(".fc-next-button").prop('disabled', false); 
                        }
                    }
                    */
                });
                
                var getUserParentMilestone = function (id) {
                    $.ajax({
                        type: 'GET',
                        url:'{{path_for('milestone-parent-user', {'id': id})}}'+id,
                        dataType: "JSON",
                        success: function (data) {
                            var ids = [];
                            $.each(data.milestones, function(k, v){
                                ids.push(v.user_id);
                            });
                            $('#add_user').val(ids).trigger('chosen:updated');
                        },
                        error: function (data) {
                            console.log(data);
                            notify('Ha ocurrido un error, al intentar cargar los usuarios!', 'warning');
                        }
                    });
                };
                var getContactMilestone = function (id) {
                    $.ajax({
                        type: 'GET',
                        url:'{{path_for('milestone-contact-user', {'id': id})}}'+id,
                        dataType: "JSON",
                        success: function (data) {
                            console.log(data);
                            var ids = [];
                            $.each(data.milestone_contacts, function(k, v){
                                ids.push(v.contact_id);
                            });
                            $('#add_contact').val(ids).trigger('chosen:updated');
                        },
                        error: function (data) {
                            console.log(data);
                            notify('Ha ocurrido un error, al intentar cargar los contactos!', 'warning');
                        }
                    });
                };
                
                var getDateView = function(d) {
                    var startD = d._d.getDate();
                    var startM = d._d.getMonth()+1;
                    var startY = d._d.getFullYear();
                    
                    return startD+"/"+ startM +"/"+startY;
                };

                //Create and ddd Action button with dropdown in Calendar header.
                var actionMenu = '<ul class="actions actions-alt" id="fc-actions">' +
                        '<li class="dropdown">' +
                        '<a href="" data-toggle="dropdown"><i class="zmdi zmdi-more-vert"></i></a>' +
                        '<ul class="dropdown-menu">' +
                        '<li class="active">' +
                        '<a data-view="month" href="">Vista de Mes</a>' +
                        '</li>' +
                        '<li>' +
                        '<a data-view="basicWeek" href="">Vista de Semana</a>' +
                        '</li>' +
                        '<li>' +
                        '<a data-view="agendaWeek" href="">Vista de Agenda</a>' +
                        '</li>' +
                        '<li>' +
                        '<a data-view="basicDay" href="">Vista de día</a>' +
                        '</li>' +
                        '<li>' +
                        '<a data-view="agendaDay" href="">Vista Agenda del día</a>' +
                        '</li>' +
                        '</ul>' +
                        '</div>' +
                        '</li>';
                cId.find('.fc-toolbar').append(actionMenu);

                //Event Tag Selector
                (function () {
                    $('body').on('click', '.event-tag > span', function () {
                        $('.event-tag > span').removeClass('selected');
                        $(this).addClass('selected');
                    });
                })();

                //Add new Event
                $('body').on('click', '#addEvent', function (e) {
                    e.preventDefault();
                    var action = $(this).data('action');
                    var eventName = $('#milestone_title').val();
                    var eventClient = $('#client_id').val();
                    
                    if (eventName != '' && eventClient > 0) { 
                        var json = $('#new-calendar').serializeArray();
                        json.user_id = $('#op_client_id').val();

                        $.ajax({
                            type: action,
                            async: false, 
                            url: action === 'POST' ? "{{path_for('new-calendar')}}" : "{{path_for('calendar-edit')}}",
                            data: json,
                            dataType: "JSON",
                            success: function(response) {
                                console.log(response);
                                if(response.status == 201) {
                                        var tagColor = $('.event-tag > span.selected').attr('data-tag');
                                        var dateR = response.milestone_date.split('/');
                                        var timeSR = response.milestone_start_time.split(':');
                                        var timeER = response.milestone_end_time.split(':');
                                        var startDate = new Date(dateR[0], dateR[1]-1, dateR[2], timeSR[0], timeSR[1], timeSR[2]);
                                        var endDate = new Date(dateR[0], dateR[1]-1, dateR[2], timeER[0], timeER[1], timeER[2]);

                                        console.log(startDate);

                                        if(action == "PUT") {
                                            cId.fullCalendar('removeEvents', response.milestone_id);
                                        }

                                        //Render Event
                                        var myEvent = {
                                            id: response.id,
                                            title: eventName,
                                            description: response.milestone_detail,
                                            start: startDate,
                                            client_id: response.client_id,
                                            time_end: response.milestone_end_time,
                                            time_start: response.milestone_start_time,
                                            end: endDate,
                                            allDay: false,
                                            className: tagColor
                                        };
                                        cId.fullCalendar('renderEvent', myEvent);
                                } else if (response.status == 202) {
                                    notify(response.error, 'warning');
                                }
                            },
                            error : function(jqXHR, status, error) {
                                notify(response.error, 'warning');
                                console.log("fail");                           
                            },
                            complete : function(jqXHR, status) {
                                $('#addNew-event').modal('hide');
                                $('#client_id option:eq(1)');
                            }
                        });

                        $('#addNew-event form')[0].reset();

                    } else {
                        if (eventName == '') { 
                            $('#milestone_title').parent().addClass('has-error');
                        }
                        
                        if (eventClient == 0 || eventClient == '') { 
                            $('#client_id').parent().addClass('has-error');
                        }
                        //notify('Campos requerido!', 'warning');
                        $('#modal-msg').html('\
                            <div class="alert alert-warning alert-dismissible" role="alert">\n\
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n\
                                    <span aria-hidden="true">×</span>\n\
                                </button>\n\
                                Completá los campos resaltados\n\
                            </div>'
                        ).show('slow');
                    }
                });
                
                $('#milestone_title').focusout(function(){
                    if($(this).parent().hasClass('has-error') && $(this).val() != '') {
                        $(this).parent().removeClass('has-error');
                    }
                });
                
                $('#client_id').change(function(){
                    $(this).parent().removeClass('has-error');
                    
                    if(!$('#milestone_title').parent().hasClass('has-error')) {
                        $('#modal-msg').hide('slow');
                    }                    
                });
                
                $('#op_client_id').change(function(){
                   var url = ""+this.value; 
                   console.log(url);
                   $('#modal_user_id').val(url);
                    $.get(url, function(data){
                        cId.fullCalendar('removeEvents'); //Stick the event

                        $.each(data, function( index, value ) {
                            var date = value.d.split("-");
                            var d = date[2];
                            var m = date[1];
                            var y = date[0];
                            var startTime = value.milestone_start_time.split(':');
                            var endTime = value.milestone_end_time.split(':');
                            
                            var myEvent = {
                                id: value.milestone_id,
                                title: value.milestone_title,
                                description: value.milestone_detail,
                                client_id: value.client_id,
                                start: new Date(y, m, d, startTime[0], startTime[1], 0),
                                end: new Date(y, m, d, endTime[0], endTime[1], 0),
                                allDay: false,
                                className: ''
                            };

                            cId.fullCalendar('renderEvent', myEvent);
                        });
                    });
                });

                //Calendar views
                $('body').on('click', '#fc-actions [data-view]', function (e) {
                    e.preventDefault();
                    var dataView = $(this).attr('data-view');

                    $('#fc-actions li').removeClass('active');
                    $(this).parent().addClass('active');
                    cId.fullCalendar('changeView', dataView);
                });
                
                $('.date-picker-calendar').datetimepicker({
                    format: 'DD/MM/YYYY',
                    minDate: moment()
                });
                
                $('#milestone_start_time').datetimepicker().on('changeDate', function(ev){
                    if (ev.date.valueOf() < date-start-display.valueOf()) {
                        
                    }
                });
                
                $("#milestone_start_time").on("dp.change", function (e) {
                    $('#milestone_end_time').data("DateTimePicker").minDate(e.date);
                });
                $("#milestone_end_time").on("dp.change", function (e) {
                    $('#milestone_start_time').data("DateTimePicker").maxDate(e.date);
                });
                
                $(document).on('keyup', 'body', function(e) {
                    if(($(".modal").data('bs.modal') || {}).isShown) {
                        //if (e.keyCode === 13) $('#addEvent').click();     // enter
                        if (e.keyCode === 27) $('#closeEvent').click();   // esc
                    }
                });

                $(document).on('change', '#send_calendar', function() {
                    if($(this).is(':checked')) {
                        $('.send_to').show();
                    } else {
                        $('.send_to').hide();
                    }
                });
                
                $('#addNew-event').on('hidden.bs.modal', function () {
                    $.each($('#add_contact option'), function(){
                        $(this).removeAttr('selected');
                    });
                    $('#add_contact').trigger('chosen:updated');
                    $.each($('#add_user option'), function(){
                        $(this).removeAttr('selected');
                    });
                    $('#add_user').trigger('chosen:updated');
                    
                    $('#milestone_title').parent().removeClass('has-error');
                    $('#client_id').parent().removeClass('has-error');
                    $('#modal-msg').hide();
                    
                    //$('#group_name').parents('.fg-line').removeClass('has-error');
                });                

                $('#addNew-event').on('keyup', '#milestone_title', function(e) {
                    if($(this).parent().hasClass('has-error') && $(this).val().length > 3) {
                        $(this).parent().removeClass('has-error');
                        
                        if(!$('#client_id').parent().hasClass('has-error')) {
                            $('#modal-msg').hide('slow');
                        }
                    }
                });
            });
            

            
            var objectifyForm = function(formArray) {//serialize data function
                var returnArray = {};
                for (var i = 0; i < formArray.length; i++){
                  returnArray[formArray[i]['name']] = formArray[i]['value'];
                }
                return returnArray;
           };
        });        
    </script>

    
{% endblock %}